#include "DeerStudio/EditorEngine/API/EditorEngine_TreeNode.h"
#include "DeerStudio/EditorEngine.h"
#include "angelscript.h"
#include "imgui.h"

namespace Deer {
    namespace EditorEngine {
        void treeNode(std::string& txt) {
            ImGuiTreeNodeFlags flags = ImGuiTreeNodeFlags_Leaf |
			                           ImGuiTreeNodeFlags_NoTreePushOnOpen |
			                           ImGuiTreeNodeFlags_SpanFullWidth;

            ImGui::TreeNodeEx((void*)0, flags, "%s", txt.c_str());
        }

        void treeNode(std::string& txt, asIScriptFunction& func) {
            ImGuiTreeNodeFlags flags = ImGuiTreeNodeFlags_OpenOnDoubleClick |
                                       ImGuiTreeNodeFlags_OpenOnArrow |
                                       ImGuiTreeNodeFlags_SpanFullWidth;

            if (ImGui::TreeNodeEx((void*)0, flags, "%s", txt.c_str())) {

                if (scriptContext && scriptContext->PushState() == asSUCCESS) {


                    scriptContext->PopState();
                } else {
                    ImGui::Text("Something failed");
                }

                ImGui::TreePop();
            }
        }
    }
}